#procedure analyzeterms(MyN,acc,terms)

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** N is the order of the Gram determinant
** `acc' is the function that accumulates the terms
** `terms' is just the maximal amount of terms acc is expected to have.
** Begun on 16/03/2004
*-------------------------------------------------------------------------------
#if `MyN' == 2
 #define imax "3"
 #define mydummy "dummy`imax'(b1?$b1,b2?$b2,b3?$b3)"
#elseif `MyN' == 3
 #define imax "6"
 #define mydummy "dummy`imax'(b1?$b1,b2?$b2,b3?$b3,b4?$b4,b5?$b5,b6?$b6)"
#endif



#do i=`imax',1,-1
 $i=0;
** We are going to run for as many terms as collected by acc
 #do run=1,`terms'
  if (match(`acc'(a1?$a1)) && $i < `terms');
** Raise one unity the running variable to avoid overcounting
   $i=$i+1;
   $termprocessed=0;
** Now we count in $termis how many we originally have
   $termis=nterms_($a1);
*   Print "Number of old terms=%$",$termis;
** By going inside the argument we don't need to unfold terms out
   argument `acc';
** By using the term environment we allow one substitution per term
** each run, and accept it if less terms are generated or refurse if more
    term;
     $termprocessed=$termprocessed+1;
*     Print "Cheking term no %$",$termprocessed;
     if ( (match(`mydummy')) && $i == $termprocessed);
*      Print "Accepting term no %$",$termprocessed;
** Here comes the substitution
      #call gramsubstitution(`MyN',`i')
     endif;
    endterm;
   endargument;
  endif;
** Now we play back! let's see how many terms were generated
  if (match(`acc'(a1?$a1)));
   $newtermis=nterms_($a1);
*   Print "Number of new terms=%$",$newtermis;

** The most positive case, hip hurra! The change is accepted
   if ($newtermis < $termis);
     $substitutions=$substitutions+1;
*    Print "Que guapo, mira los terminos %$",$a1;
    argument `acc';
     if (count([Gram`MyN'],1) == 1 && (match(Gram(`MyN')) == 0));
      id [Gram`MyN']*dummy`imax'(?a)=Gram(`MyN')*dummy`imax'(?a);
*     id [Gram`MyN']=1/IGram(`MyN');
     endif;
    endargument;
**Let's see what happen if we jump out
*    goto sacamedeaqui;

** Neutral: We have the same terms, maybe we picked up something positive.
** I found a bug here, some terms were repeated without success!
   elseif ($newtermis = $termis);
*      $substitutions=$substitutions+1;
*    Print "Que tranqui";
    argument `acc';
     if (count([Gram`MyN'],1) == 1 && (match(Gram(`MyN')) == 0));
*      $substitutions=$substitutions+1;
      id [Gram`MyN']*dummy`imax'(?a)=Gram(`MyN')*dummy`imax'(?a);
     endif;
    endargument;

** The interesting thing: we return back to the old expression.
   elseif ($newtermis > $termis);
*   elseif ($newtermis > $termis);
*    Print "Que mierda, mira los terminos %$",$a1;
    argument `acc';
     #call gramback(`MyN')
    endargument;
   endif;

  endif;
 #enddo !of term running
#enddo !of conditional substitution running
 label sacamedeaqui;
#endprocedure

